OPENDIR(3)

NAME
opendir, fdopendir - open a directory

SYNOPSIS
#include <sys/types.h>
#include <dirent.h>

DIR *opendir(const char *name);
DIR *fdopendir(int fd);

DESCRIPTION
The opendir() function opens a directory stream corresponding to the directory name, and returns a pointer to the directory stream. The stream is positioned at the first entry in the directory. The fdopendir() is like opendir(), but returns a directory stream for the directory referred to by the open file descriptor fd. After a successful call to fdopendir(), fd is used internally by the implementation, and should not otherwise be used by the application.

RETURN VALUE
The opendir() and fdopendir() functions return a pointer to the directory stream. On error, NULL is returned, and errno is set appropriately.

ERRORS

EACCES
    Permission denied.

EBADF
    fd is not a valid file descriptor opened for reading.

EMFILE
    Too many file descriptors in use by process.

ENFILE
    Too many files are currently open in the system.

ENOENT
    Directory does not exist, or name is an empty string.

ENOMEM
    Insufficient memory to complete the operation.

ENOTDIR
    name is not a directory.

VERSIONS
fdopendir() is available in glibc since version 2.4.

CONFORMING TO
opendir() is present on SVr4, 4.3BSD, and specified in POSIX.1-2001. fdopendir() is under consideration for inclusion in the next version of POSIX.1.

NOTES
The underlying file descriptor of the directory stream can be obtained using dirfd(3).

SEE ALSO
open(2), closedir(3), dirfd(3), readdir(3), rewinddir(3), scandir(3), seekdir(3), telldir(3)

COLOPHON
This page is part of release 2.79 of the Linux man-pages project. A description of the project, and information about reporting bugs, can be found at http://www.kernel.org/doc/man-pages/.